Orders Slip

This sample demonstrates a Orders Slip view created with the MultiRow control.

Learn about MultiRow | MultiRow API Reference

import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import * as wjCore from '@mescius/wijmo'; import * as wjPdf from '@mescius/wijmo.pdf'; import * as wjMultiRow from '@mescius/wijmo.grid.multirow'; import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx'; import * as wjGridPdf from '@mescius/wijmo.grid.pdf'; import { generateOrdersSlipData } from './data'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { let data = generateOrdersSlipData(); let ordersSlip = new wjMultiRow.MultiRow('#ordersSlip', { itemsSource: data, layoutDefinition: generateLayoutDef() }); let cv = ordersSlip.collectionView; cv.collectionChanged.addHandler((sender, e) => { let unitPrice, quantity; if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) { unitPrice = +e.item.unitPrice; quantity = +e.item.quantity; if (!isNaN(unitPrice) && !isNaN(quantity)) { e.item.amount = unitPrice * quantity; } } }); // Generate the layout definition for the MultiRow control. function generateLayoutDef() { return [ { colspan: 3, cells: [ { binding: 'productId', header: 'Product ID', width: 90 }, { binding: 'categoryId', header: 'Category ID', width: 90 }, { binding: 'categoryName', header: 'Category', width: 90 }, { binding: 'productName', header: 'Product Name', colspan: 3 } ] }, { cells: [ { binding: 'quantity', header: 'Quantity', width: 140 }, { binding: 'packageUnit', header: 'Package Unit', width: 140 } ] }, { cells: [ { binding: 'unitPrice', header: 'Unit Price', format: 'c2', width: 80 } ] }, { cells: [ { binding: 'amount', header: 'Amount', isReadOnly: true, format: 'c2', width: 80 } ] }, { cells: [ { binding: 'shippingId', header: 'Shipping ID', width: 100 }, { binding: 'discontinued', header: 'Discontinued', width: 100 } ] }, { cells: [ { binding: 'remarks', header: 'Remarks', width: 280 }, { binding: 'description', header: 'Product Description', width: 280 } ] } ]; } document.querySelector('#exportXlsx').addEventListener('click', () => { wjGridXlsx.FlexGridXlsxConverter.saveAsync(ordersSlip, null, 'OrdersSlip.xlsx'); }); document.querySelector('#exportPdf').addEventListener('click', () => { let doc = new wjPdf.PdfDocument({ header: { declarative: { text: '\t&[Page]\\&[Pages]' } }, footer: { declarative: { text: '\t&[Page]\\&[Pages]' } }, ended: function (sender, args) { wjPdf.saveBlob(args.blob, 'OrdersSlip.pdf'); } }), settings = { styles: { cellStyle: { backgroundColor: '#ffffff', borderColor: '#c6c6c6' }, altCellStyle: { backgroundColor: '#C0FFC0' }, headerCellStyle: { backgroundColor: '#eaeaea' } } }; wjGridPdf.FlexGridPdfConverter.draw(ordersSlip, doc, null, null, settings); doc.end(); }); }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>MESCIUS Wijmo MultiRow Orders Slip</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div class="container-fluid"> <div id="ordersSlip"></div> <div class="btn-group"> <button class="btn btn-outline-secondary" id="exportXlsx"> Export to Excel </button> <button class="btn btn-outline-secondary" id="exportPdf"> Export to PDF </button> </div> </div> </body> </html>
export function generateOrdersSlipData() { return [ { productId: 1, productName: 'Chai', categoryId: 1, categoryName: 'Beverages', quantity: 100, packageUnit: '10 boxes x 20 bags', unitPrice: 18, amount: 100 * 18, shippingId: 1, discontinued: false, remarks: '', description: 'Soft drinks, coffees, teas, beers, and ales' }, { productId: 2, productName: 'Chang', categoryId: 1, categoryName: 'Beverages', quantity: 120, packageUnit: '24 - 12 oz bottles', unitPrice: 19, amount: 120 * 19, shippingId: 1, discontinued: false, remarks: '', description: 'Soft drinks, coffees, teas, beers, and ales' }, { productId: 3, productName: 'Aniseed Syrup', categoryId: 2, categoryName: 'Condiments', quantity: 80, packageUnit: '12 - 550 ml bottles', unitPrice: 10, amount: 100 * 18, shippingId: 1, discontinued: false, remarks: '', description: '' }, { productId: 4, productName: 'Chef Anton\'s Gumbo Mix', categoryId: 2, categoryName: 'Condiments', quantity: 125, packageUnit: '36 boxes', unitPrice: 21.35, amount: 125 * 21.35, shippingId: 2, discontinued: false, remarks: '', description: '' }, { productId: 5, productName: 'Uncle Bob\'s Organic Dried Pears', categoryId: 7, categoryName: 'Produce', quantity: 60, packageUnit: '12 - 1 lb pkgs', unitPrice: 30, amount: 30 * 60, shippingId: 2, discontinued: false, remarks: '', description: 'Dried fruit and bean curd' }, { productId: 6, productName: 'Mishi Kobe Niku', categoryId: 6, categoryName: 'Meat/Poultry', quantity: 25, packageUnit: '18 - 500 g pkgs', unitPrice: 97, amount: 25 * 97, shippingId: 4, discontinued: true, remarks: '', description: 'Prepared meats' }, { productId: 7, productName: 'Ikura', categoryId: 8, categoryName: 'Seafood', quantity: 60, packageUnit: '12 - 200 ml jars', unitPrice: 31, amount: 60 * 31, shippingId: 4, discontinued: false, remarks: '', description: 'Seaweed and fish' }, { productId: 8, productName: 'Queso Cabrales', categoryId: 4, categoryName: 'Dairy Products', quantity: 90, packageUnit: '1 kg pkg', unitPrice: 21, amount: 90 * 21, shippingId: 5, discontinued: false, remarks: '', description: 'Cheeses' } ]; }
.wj-multirow { height: 400px; margin: 6px 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, }, meta: { '*.css': { loader: 'css' }, }, paths: { // paths serve as alias 'npm:': 'node_modules/', 'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/', 'pcdn:': 'https://cdn.jsdelivr.net/npm/' }, // map tells the System loader where to look for things map: { '@mescius/wijmo': 'cdn:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js', jszip: 'pcdn:jszip@3.8.0/dist/jszip.js', 'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css', css: 'pcdn:systemjs-plugin-css@0.1.37/css.js', 'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js', }, node_modules: { defaultExtension: 'js', }, }, }); })(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjCore from '@mescius/wijmo';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjMultirow from '@mescius/wijmo.grid.multirow';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridMultirowModule } from '@mescius/wijmo.angular2.grid.multirow';
import { DataService, OrdersSlipData, Line } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridMultirowModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements AfterViewInit {
@ViewChild('ordersSlip', { static: true }) ordersSlip: wjMultirow.MultiRow;
data: OrdersSlipData[];
layoutDefinition: Line[];
// DataSvc will be passed by derived classes
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.generateOrdersSlipData();
this.layoutDefinition = dataService.generateLayoutDef();
}
//
ngAfterViewInit() {
let cv = <wjCore.CollectionView>this.ordersSlip.collectionView;
cv.collectionChanged.addHandler((sender: any, e: wjCore.NotifyCollectionChangedEventArgs) => {
let unitPrice: number, quantity: number;
if (e.action === wjCore.NotifyCollectionChangedAction.Change && !!e.item) {
unitPrice = +e.item.unitPrice;
quantity = +e.item.quantity;
if (!isNaN(unitPrice) && !isNaN(quantity)) {
e.item.amount = unitPrice * quantity;
}
}
});
}
//
onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(this.ordersSlip, null, 'OrdersSlip.xlsx');
}
onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]',
},
},
ended: function (sender: wjPdf.PdfDocument, args: wjPdf.PdfDocumentEndedEventArgs) {
wjPdf.saveBlob(args.blob, 'OrdersSlip.pdf');
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6',
},
altCellStyle: {
backgroundColor: '#C0FFC0',
},
headerCellStyle: {
backgroundColor: '#eaeaea',
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(this.ordersSlip, doc, null, null, settings);
doc.end();
}
}
//\\
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Orders Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<wj-multi-row #ordersSlip [itemsSource]="data" [layoutDefinition]="layoutDefinition"></wj-multi-row>
<div class="btn-group">
<button class="btn btn-default" (click)="onExportXlsxClick()">
Export to Excel
</button>
<button class="btn btn-default" (click)="onExportPdfClick()">
Export to PDF
</button>
</div>
</div>
import { Injectable } from '@angular/core';
export interface OrdersSlipData {
productId: number;
productName: string;
categoryId: number;
categoryName: string;
quantity: number;
packageUnit: string;
unitPrice: number;
amount: number;
shippingId: number;
discontinued: boolean;
remarks: string;
description: string;
}
export interface Cell {
binding: string;
header: string;
cssClass?: string;
format?: string;
isReadOnly?: boolean;
wordWrap?: boolean;
width?: number;
colspan?: number;
align?: string;
}
export interface Line {
cells: Cell[];
header?: string;
colspan?: number;
}
@Injectable()
export class DataService {
generateOrdersSlipData(): OrdersSlipData[] {
return [
{
productId: 1,
productName: 'Chai',
categoryId: 1,
categoryName: 'Beverages',
quantity: 100,
packageUnit: '10 boxes x 20 bags',
unitPrice: 18,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 2,
productName: 'Chang',
categoryId: 1,
categoryName: 'Beverages',
quantity: 120,
packageUnit: '24 - 12 oz bottles',
unitPrice: 19,
amount: 120 * 19,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 3,
productName: 'Aniseed Syrup',
categoryId: 2,
categoryName: 'Condiments',
quantity: 80,
packageUnit: '12 - 550 ml bottles',
unitPrice: 10,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 4,
productName: 'Chef Anton\'s Gumbo Mix',
categoryId: 2,
categoryName: 'Condiments',
quantity: 125,
packageUnit: '36 boxes',
unitPrice: 21.35,
amount: 125 * 21.35,
shippingId: 2,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 5,
productName: 'Uncle Bob\'s Organic Dried Pears',
categoryId: 7,
categoryName: 'Produce',
quantity: 60,
packageUnit: '12 - 1 lb pkgs',
unitPrice: 30,
amount: 30 * 60,
shippingId: 2,
discontinued: false,
remarks: '',
description: 'Dried fruit and bean curd'
},
{
productId: 6,
productName: 'Mishi Kobe Niku',
categoryId: 6,
categoryName: 'Meat/Poultry',
quantity: 25,
packageUnit: '18 - 500 g pkgs',
unitPrice: 97,
amount: 25 * 97,
shippingId: 4,
discontinued: true,
remarks: '',
description: 'Prepared meats'
},
{
productId: 7,
productName: 'Ikura',
categoryId: 8,
categoryName: 'Seafood',
quantity: 60,
packageUnit: '12 - 200 ml jars',
unitPrice: 31,
amount: 60 * 31,
shippingId: 4,
discontinued: false,
remarks: '',
description: 'Seaweed and fish'
},
{
productId: 8,
productName: 'Queso Cabrales',
categoryId: 4,
categoryName: 'Dairy Products',
quantity: 90,
packageUnit: '1 kg pkg',
unitPrice: 21,
amount: 90 * 21,
shippingId: 5,
discontinued: false,
remarks: '',
description: 'Cheeses'
}
]
}
generateLayoutDef(): Line[] {
return [
{
colspan: 3,
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 },
{ binding: 'categoryId', header: 'Category ID', width: 90 },
{ binding: 'categoryName', header: 'Category', width: 90 },
{ binding: 'productName', header: 'Product Name', colspan: 3 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 140 },
{ binding: 'packageUnit', header: 'Package Unit', width: 140 }
]
},
{
cells: [
{ binding: 'unitPrice', header: 'Unit Price', format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'amount', header: 'Amount', isReadOnly: true, format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'shippingId', header: 'Shipping ID', width: 100 },
{ binding: 'discontinued', header: 'Discontinued', width: 100 }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', width: 280 },
{ binding: 'description', header: 'Product Description', width: 280 }
]
}
];
}
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

<template>
<div class="container-fluid">
<wj-multi-row :initialized="initSlip" :itemsSource="data" :layoutDefinition="layoutDefinition"></wj-multi-row>
<div class="btn-group">
<button class="btn btn-default" @click="onExportXlsxClick">
Export to Excel
</button>
<button class="btn btn-default" @click="onExportPdfClick">
Export to PDF
</button>
</div>
</div>
</template>
<script setup>
import * as wjPdf from "@mescius/wijmo.pdf";
import * as wjGridXlsx from "@mescius/wijmo.grid.xlsx";
import * as wjGridPdf from "@mescius/wijmo.grid.pdf";
import { generateOrdersSlipData, generateLayoutDef } from "./data";
import { ref } from "vue";
const data = ref(generateOrdersSlipData());
const layoutDefinition = ref(generateLayoutDef());
const ordersSlip = ref(null);
function initSlip(ordersSlipref) {
ordersSlip.value = ordersSlipref;
}
function _getData() {
let countries = "US,Germany,UK,Japan,Italy,Greece".split(","),
data = [];
for (let i = 0; i < countries.length; i++) {
data.push({
country: countries[i],
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
});
}
return data;
}
function onExportXlsxClick() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(ordersSlip.value, null, "OrdersSlip.xlsx");
}
function onExportPdfClick() {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
footer: {
declarative: {
text: "\t&[Page]\\&[Pages]",
},
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, "OrdersSlip.pdf");
},
}),
settings = {
styles: {
cellStyle: {
backgroundColor: "#ffffff",
borderColor: "#c6c6c6",
},
altCellStyle: {
backgroundColor: "#C0FFC0",
},
headerCellStyle: {
backgroundColor: "#eaeaea",
},
},
};
wjGridPdf.FlexGridPdfConverter.draw(ordersSlip.value, doc, null, null, settings);
doc.end();
}
</script>
<style>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo MultiRow Orders Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function generateOrdersSlipData(){
return [
{
productId: 1,
productName: 'Chai',
categoryId: 1,
categoryName: 'Beverages',
quantity: 100,
packageUnit: '10 boxes x 20 bags',
unitPrice: 18,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 2,
productName: 'Chang',
categoryId: 1,
categoryName: 'Beverages',
quantity: 120,
packageUnit: '24 - 12 oz bottles',
unitPrice: 19,
amount: 120 * 19,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 3,
productName: 'Aniseed Syrup',
categoryId: 2,
categoryName: 'Condiments',
quantity: 80,
packageUnit: '12 - 550 ml bottles',
unitPrice: 10,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 4,
productName: 'Chef Anton\'s Gumbo Mix',
categoryId: 2,
categoryName: 'Condiments',
quantity: 125,
packageUnit: '36 boxes',
unitPrice: 21.35,
amount: 125 * 21.35,
shippingId: 2,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 5,
productName: 'Uncle Bob\'s Organic Dried Pears',
categoryId: 7,
categoryName: 'Produce',
quantity: 60,
packageUnit: '12 - 1 lb pkgs',
unitPrice: 30,
amount: 30 * 60,
shippingId: 2,
discontinued: false,
remarks: '',
description: 'Dried fruit and bean curd'
},
{
productId: 6,
productName: 'Mishi Kobe Niku',
categoryId: 6,
categoryName: 'Meat/Poultry',
quantity: 25,
packageUnit: '18 - 500 g pkgs',
unitPrice: 97,
amount: 25 * 97,
shippingId: 4,
discontinued: true,
remarks: '',
description: 'Prepared meats'
},
{
productId: 7,
productName: 'Ikura',
categoryId: 8,
categoryName: 'Seafood',
quantity: 60,
packageUnit: '12 - 200 ml jars',
unitPrice: 31,
amount: 60 * 31,
shippingId: 4,
discontinued: false,
remarks: '',
description: 'Seaweed and fish'
},
{
productId: 8,
productName: 'Queso Cabrales',
categoryId: 4,
categoryName: 'Dairy Products',
quantity: 90,
packageUnit: '1 kg pkg',
unitPrice: 21,
amount: 90 * 21,
shippingId: 5,
discontinued: false,
remarks: '',
description: 'Cheeses'
}
]
}
export function generateLayoutDef(){
return [
{
colspan: 3,
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 },
{ binding: 'categoryId', header: 'Category ID', width: 90 },
{ binding: 'categoryName', header: 'Category', width: 90 },
{ binding: 'productName', header: 'Product Name', colspan: 3 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 140 },
{ binding: 'packageUnit', header: 'Package Unit', width: 140 }
]
},
{
cells: [
{ binding: 'unitPrice', header: 'Unit Price', format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'amount', header: 'Amount', isReadOnly: true, format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'shippingId', header: 'Shipping ID', width: 100 },
{ binding: 'discontinued', header: 'Discontinued', width: 100 }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', width: 280 },
{ binding: 'description', header: 'Product Description', width: 280 }
]
}
];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjGrid from '@mescius/wijmo.react.grid.multirow';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import './app.css';
import { data, layoutDefinition } from './data';
function App() {
const [ordersSlip, setOrdersSlip] = useState(null);
const initSlip = useEvent((ordersSlip) => {
setOrdersSlip(ordersSlip);
});
const onExportXlsxClick = () => {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(ordersSlip, undefined, 'OrdersSlip.xlsx');
};
const onExportPdfClick = () => {
let doc = new wjPdf.PdfDocument({
header: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
footer: {
declarative: {
text: '\t&[Page]\\&[Pages]'
}
},
ended: function (sender, args) {
wjPdf.saveBlob(args.blob, 'OrdersSlip.pdf');
}
}), settings = {
styles: {
cellStyle: {
backgroundColor: '#ffffff',
borderColor: '#c6c6c6'
},
altCellStyle: {
backgroundColor: '#C0FFC0'
},
headerCellStyle: {
backgroundColor: '#eaeaea'
}
}
};
wjGridPdf.FlexGridPdfConverter.draw(ordersSlip, doc, undefined, undefined, settings);
doc.end();
};
return (<div className="container-fluid">
<wjGrid.MultiRow itemsSource={data} layoutDefinition={layoutDefinition} initialized={initSlip}/>
<div className="btn-group">
<button className="btn btn-default" onClick={onExportXlsxClick}>
Export to Excel
</button>
<button className="btn btn-default" onClick={onExportPdfClick}>
Export to PDF
</button>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo MultiRow Orders Slip</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="node_modules/jszip/dist/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-multirow {
height: 400px;
margin: 6px 0;
}
function generateOrdersSlipData() {
return [
{
productId: 1,
productName: 'Chai',
categoryId: 1,
categoryName: 'Beverages',
quantity: 100,
packageUnit: '10 boxes x 20 bags',
unitPrice: 18,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 2,
productName: 'Chang',
categoryId: 1,
categoryName: 'Beverages',
quantity: 120,
packageUnit: '24 - 12 oz bottles',
unitPrice: 19,
amount: 120 * 19,
shippingId: 1,
discontinued: false,
remarks: '',
description: 'Soft drinks, coffees, teas, beers, and ales'
},
{
productId: 3,
productName: 'Aniseed Syrup',
categoryId: 2,
categoryName: 'Condiments',
quantity: 80,
packageUnit: '12 - 550 ml bottles',
unitPrice: 10,
amount: 100 * 18,
shippingId: 1,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 4,
productName: 'Chef Anton\'s Gumbo Mix',
categoryId: 2,
categoryName: 'Condiments',
quantity: 125,
packageUnit: '36 boxes',
unitPrice: 21.35,
amount: 125 * 21.35,
shippingId: 2,
discontinued: false,
remarks: '',
description: ''
},
{
productId: 5,
productName: 'Uncle Bob\'s Organic Dried Pears',
categoryId: 7,
categoryName: 'Produce',
quantity: 60,
packageUnit: '12 - 1 lb pkgs',
unitPrice: 30,
amount: 30 * 60,
shippingId: 2,
discontinued: false,
remarks: '',
description: 'Dried fruit and bean curd'
},
{
productId: 6,
productName: 'Mishi Kobe Niku',
categoryId: 6,
categoryName: 'Meat/Poultry',
quantity: 25,
packageUnit: '18 - 500 g pkgs',
unitPrice: 97,
amount: 25 * 97,
shippingId: 4,
discontinued: true,
remarks: '',
description: 'Prepared meats'
},
{
productId: 7,
productName: 'Ikura',
categoryId: 8,
categoryName: 'Seafood',
quantity: 60,
packageUnit: '12 - 200 ml jars',
unitPrice: 31,
amount: 60 * 31,
shippingId: 4,
discontinued: false,
remarks: '',
description: 'Seaweed and fish'
},
{
productId: 8,
productName: 'Queso Cabrales',
categoryId: 4,
categoryName: 'Dairy Products',
quantity: 90,
packageUnit: '1 kg pkg',
unitPrice: 21,
amount: 90 * 21,
shippingId: 5,
discontinued: false,
remarks: '',
description: 'Cheeses'
}
];
}
function generateLayoutDef() {
return [
{
colspan: 3,
cells: [
{ binding: 'productId', header: 'Product ID', width: 90 },
{ binding: 'categoryId', header: 'Category ID', width: 90 },
{ binding: 'categoryName', header: 'Category', width: 90 },
{ binding: 'productName', header: 'Product Name', colspan: 3 }
]
},
{
cells: [
{ binding: 'quantity', header: 'Quantity', width: 140 },
{ binding: 'packageUnit', header: 'Package Unit', width: 140 }
]
},
{
cells: [
{ binding: 'unitPrice', header: 'Unit Price', format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'amount', header: 'Amount', isReadOnly: true, format: 'c2', width: 80 }
]
},
{
cells: [
{ binding: 'shippingId', header: 'Shipping ID', width: 100 },
{ binding: 'discontinued', header: 'Discontinued', width: 100 }
]
},
{
cells: [
{ binding: 'remarks', header: 'Remarks', width: 280 },
{ binding: 'description', header: 'Product Description', width: 280 }
]
}
];
}
export const data = generateOrdersSlipData();
export const layoutDefinition = generateLayoutDef();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);